/* Pseudo device library routines Copyright (C), Lawrence Foard, 1992 
 * May be used under the gnu library license
 * I may be contacted at:
 * lfoard@turing.org, entropy@world.std.com, 
 * entropy on the VWIS Linux support BBS 1-508-793-9568 
 * Snail mail:
 * Lawrence Foard
 * Suite #791
 * 1415 Main st.
 * Worcester ma 01603
 */

#ifndef FILTER_H
#define FILTER_H

#ifndef PSEUDO_LIB_H
#include <pseudo_lib.h>
#endif

typedef struct blocking BLOCKING;

struct blocking
 {
  int bsize;
  char *tmp_blk;
  int (*read_fun)();
  int (*write_fun)();
  void *data;
 };

BLOCKING *open_blocking(int bsize,int (*read_fun)(),int (*write_fun)(),void *data);
void close_blocking(BLOCKING *blocking);
int read_blocking(BLOCKING *blocking,int pos,char *buf,int count);
int write_blocking(BLOCKING *blocking,int pos,char *buf,int count);

#endif
