/* Pseudo device library routines Copyright (C), Lawrence Foard, 1992 
 * May be used under the gnu library license
 */
#include <stdio.h>
#include <fcntl.h>
#include <filters.h>

typedef struct ramdisk RAMDISK;

struct ramdisk
 {
  PSEUDO *pseudo;
  char *ram;
  int size;
 };

static read_data(RAMDISK *ramdisk,int pos,char *buf,int count)
 {
/*  printf("read-pos=%d count=%d\n",pos,count);*/
  if (count!=131)
   exit(1);
  memcpy(buf,ramdisk->ram+pos,count);
  return(count);
 }

static write_data(RAMDISK *ramdisk,int pos,char *buf,int count)
 {
/*  printf("write-pos=%d count=%d\n",pos,count);*/
  if (count!=131)
   exit(1);
  memcpy(ramdisk->ram+pos,buf,count);
  return(count);
 }

main(int argc,char *argv[])
 {
  RAMDISK ramdisk;
  BLOCKING *blocking;
  if (!argv[1] || !argv[2])
   {
    fprintf(stderr,"Usage: [device name] [size in K]\n");
    exit(1);
   }
  blocking=open_blocking(131,read_data,write_data,&ramdisk);
  if (!(ramdisk.pseudo=open_pseudo(argv[1])))
   {
    perror(argv[1]);
    exit(1);
   }
  ramdisk.size=atoi(argv[2])*1024;
  ramdisk.ram=(char *)sbrk(ramdisk.size);
  size_pseudo(ramdisk.pseudo,ramdisk.size);
 /* run_pseudo(ramdisk.pseudo,read_data,write_data,&ramdisk);*/
  run_pseudo(ramdisk.pseudo,read_blocking,write_blocking,blocking);
 }
